/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIAccessible.idl
 */

#ifndef __gen_nsIAccessible_h__
#define __gen_nsIAccessible_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIArray_h__
#include "nsIArray.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIPersistentProperties; /* forward declaration */


/* starting interface:    nsIAccessible */
#define NS_IACCESSIBLE_IID_STR "1b9596e8-d7bf-4b99-b032-53a1bf9be1c3"

#define NS_IACCESSIBLE_IID \
  {0x1b9596e8, 0xd7bf, 0x4b99, \
    { 0xb0, 0x32, 0x53, 0xa1, 0xbf, 0x9b, 0xe1, 0xc3 }}

/**
 * A cross-platform interface that supports platform-specific 
 * accessibility APIs like MSAA and ATK. Contains the sum of what's needed
 * to support IAccessible as well as ATK's generic accessibility objects.
 * Can also be used by in-process accessibility clients to get information
 * about objects in the accessible tree. The accessible tree is a subset of 
 * nodes in the DOM tree -- such as documents, focusable elements and text.
 * Mozilla creates the implementations of nsIAccessible on demand.
 * See http://www.mozilla.org/projects/ui/accessibility for more information.
 *
 * @status UNDER_REVIEW
 */
class NS_NO_VTABLE nsIAccessible : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IACCESSIBLE_IID)

  /**
   * Parent node in accessible tree.
   */
  /* readonly attribute nsIAccessible parent; */
  NS_IMETHOD GetParent(nsIAccessible * *aParent) = 0;

  /**
   * Next sibling in accessible tree
   */
  /* readonly attribute nsIAccessible nextSibling; */
  NS_IMETHOD GetNextSibling(nsIAccessible * *aNextSibling) = 0;

  /**
   * Previous sibling in accessible tree
   */
  /* readonly attribute nsIAccessible previousSibling; */
  NS_IMETHOD GetPreviousSibling(nsIAccessible * *aPreviousSibling) = 0;

  /**
   * First child in accessible tree
   */
  /* readonly attribute nsIAccessible firstChild; */
  NS_IMETHOD GetFirstChild(nsIAccessible * *aFirstChild) = 0;

  /**
   * Last child in accessible tree
   */
  /* readonly attribute nsIAccessible lastChild; */
  NS_IMETHOD GetLastChild(nsIAccessible * *aLastChild) = 0;

  /**
   * Array of all this element's children.
   */
  /* readonly attribute nsIArray children; */
  NS_IMETHOD GetChildren(nsIArray * *aChildren) = 0;

  /**
   * Number of accessible children
   */
  /* readonly attribute long childCount; */
  NS_IMETHOD GetChildCount(PRInt32 *aChildCount) = 0;

  /**
   * The 0-based index of this accessible in its parent's list of children,
   * or -1 if this accessible does not have a parent.
   */
  /* readonly attribute long indexInParent; */
  NS_IMETHOD GetIndexInParent(PRInt32 *aIndexInParent) = 0;

  /**
   * Accessible name -- the main text equivalent for this node
   */
  /* attribute AString name; */
  NS_IMETHOD GetName(nsAString & aName) = 0;
  NS_IMETHOD SetName(const nsAString & aName) = 0;

  /**
   * Accessible value -- a number or a secondary text equivalent for this node
   * Widgets that use role attribute can force a value using the valuenow attribute
   */
  /* readonly attribute AString value; */
  NS_IMETHOD GetValue(nsAString & aValue) = 0;

  /**
   * Accessible description -- long text associated with this node
   */
  /* readonly attribute AString description; */
  NS_IMETHOD GetDescription(nsAString & aDescription) = 0;

  /**
   * Provides localized string of accesskey name, such as Alt+D.
   * The modifier may be affected by user and platform preferences.
   * Usually alt+letter, or just the letter alone for menu items. 
   */
  /* readonly attribute AString keyboardShortcut; */
  NS_IMETHOD GetKeyboardShortcut(nsAString & aKeyboardShortcut) = 0;

  /**
   * Provides localized string of global keyboard accelerator, such
   * as Ctrl+O for Open file
   */
  /* readonly attribute AString keyBinding; */
  NS_IMETHOD GetKeyBinding(nsAString & aKeyBinding) = 0;

  /**
   * Natural enumerated accessible role for the associated element.
   * The values depend on platform because of variations.
   * See the ROLE_* constants defined later in this file.
   * This does not take into account role attribute as the finalRole does.
   */
  /* readonly attribute unsigned long role; */
  NS_IMETHOD GetRole(PRUint32 *aRole) = 0;

  /**
   * Enumerated accessible role. The values depend on platform because of variations.
   * See the ROLE_* constants defined later in this file.
   * Widgets can use role attribute to force the final role
   */
  /* readonly attribute unsigned long finalRole; */
  NS_IMETHOD GetFinalRole(PRUint32 *aFinalRole) = 0;

  /**
   * Accessible states -- bit field which describes boolean properties of node. 
   * See the STATE_* constants defined later in this file.
   * Many states are only valid given a certain role attribute that supports them
   */
  /* readonly attribute unsigned long finalState; */
  NS_IMETHOD GetFinalState(PRUint32 *aFinalState) = 0;

  /**
   * Extended accessible states -- second bit field describing node
   */
  /* readonly attribute unsigned long extState; */
  NS_IMETHOD GetExtState(PRUint32 *aExtState) = 0;

  /**
   * True if this element is live in an editor.
   * False if the content is being displayed but not edited. 
   */
  /* readonly attribute boolean isEditable; */
  NS_IMETHOD GetIsEditable(PRBool *aIsEditable) = 0;

  /**
   * Help text associated with node
   */
  /* readonly attribute AString help; */
  NS_IMETHOD GetHelp(nsAString & aHelp) = 0;

  /**
   * Focused accessible child of node
   */
  /* readonly attribute nsIAccessible focusedChild; */
  NS_IMETHOD GetFocusedChild(nsIAccessible * *aFocusedChild) = 0;

  /**
   * Attributes of accessible
   */
  /* readonly attribute nsIPersistentProperties attributes; */
  NS_IMETHOD GetAttributes(nsIPersistentProperties * *aAttributes) = 0;

  /**
   * Accessible child which contains the coordinate at (x, y) in screen pixels.
   */
  /* nsIAccessible getChildAtPoint (in long x, in long y); */
  NS_IMETHOD GetChildAtPoint(PRInt32 x, PRInt32 y, nsIAccessible **_retval) = 0;

  /**
   * Nth accessible child using zero-based index or last child if index less than zero
   */
  /* nsIAccessible getChildAt (in long aChildIndex); */
  NS_IMETHOD GetChildAt(PRInt32 aChildIndex, nsIAccessible **_retval) = 0;

  /**
   * Accessible node geometrically to the right of this one
   */
  /* nsIAccessible getAccessibleToRight (); */
  NS_IMETHOD GetAccessibleToRight(nsIAccessible **_retval) = 0;

  /**
   * Accessible node geometrically to the left of this one
   */
  /* nsIAccessible getAccessibleToLeft (); */
  NS_IMETHOD GetAccessibleToLeft(nsIAccessible **_retval) = 0;

  /**
   * Accessible node geometrically above this one
   */
  /* nsIAccessible getAccessibleAbove (); */
  NS_IMETHOD GetAccessibleAbove(nsIAccessible **_retval) = 0;

  /**
   * Accessible node geometrically below this one
   */
  /* nsIAccessible getAccessibleBelow (); */
  NS_IMETHOD GetAccessibleBelow(nsIAccessible **_retval) = 0;

  /**
   * Accessible node related to this one 
   */
  /* nsIAccessible getAccessibleRelated (in unsigned long aRelationType); */
  NS_IMETHOD GetAccessibleRelated(PRUint32 aRelationType, nsIAccessible **_retval) = 0;

  /* void getBounds (out long x, out long y, out long width, out long height); */
  NS_IMETHOD GetBounds(PRInt32 *x, PRInt32 *y, PRInt32 *width, PRInt32 *height) = 0;

  /**
   * Add or remove this accessible to the current selection
   */
  /* void setSelected (in boolean isSelected); */
  NS_IMETHOD SetSelected(PRBool isSelected) = 0;

  /**
   * Extend the current selection from its current accessible anchor node
   * to this accessible
   */
  /* void extendSelection (); */
  NS_IMETHOD ExtendSelection(void) = 0;

  /**
   * Select this accessible node only
   */
  /* void takeSelection (); */
  NS_IMETHOD TakeSelection(void) = 0;

  /**
   * Focus this accessible node,
   * The state STATE_FOCUSABLE indicates whether this node is normally focusable.
   * It is the callers responsibility to determine whether this node is focusable.
   * accTakeFocus on a node that is not normally focusable (such as a table),
   * will still set focus on that node, although normally that will not be visually 
   * indicated in most style sheets.
   */
  /* void takeFocus (); */
  NS_IMETHOD TakeFocus(void) = 0;

  /**
   * The number of accessible actions associated with this accessible
   */
  /* readonly attribute PRUint8 numActions; */
  NS_IMETHOD GetNumActions(PRUint8 *aNumActions) = 0;

  /**
   * The name of the accessible action at the given zero-based index
   */
  /* AString getActionName (in PRUint8 index); */
  NS_IMETHOD GetActionName(PRUint8 index, nsAString & _retval) = 0;

  /**
   * Perform the accessible action at the given zero-based index
   * Action number 0 is the default action
   */
  /* void doAction (in PRUint8 index); */
  NS_IMETHOD DoAction(PRUint8 index) = 0;

  /**
   * Get a pointer to accessibility interface for this node, which is specific 
   * to the OS/accessibility toolkit we're running on.
   */
  /* [noscript] void getNativeInterface (out voidPtr aOutAccessible); */
  NS_IMETHOD GetNativeInterface(void * *aOutAccessible) = 0;

  /**
   * MSAA State flags - used for bitfield. More than 1 allowed.
   */
  enum { STATE_UNAVAILABLE = 1U };

  enum { STATE_SELECTED = 2U };

  enum { STATE_FOCUSED = 4U };

  enum { STATE_PRESSED = 8U };

  enum { STATE_CHECKED = 16U };

  enum { STATE_MIXED = 32U };

  enum { STATE_READONLY = 64U };

  enum { STATE_HOTTRACKED = 128U };

  enum { STATE_DEFAULT = 256U };

  enum { STATE_EXPANDED = 512U };

  enum { STATE_COLLAPSED = 1024U };

  enum { STATE_BUSY = 2048U };

  enum { STATE_FLOATING = 4096U };

  enum { STATE_MARQUEED = 8192U };

  enum { STATE_ANIMATED = 16384U };

  enum { STATE_INVISIBLE = 32768U };

  enum { STATE_OFFSCREEN = 65536U };

  enum { STATE_SIZEABLE = 131072U };

  enum { STATE_MOVEABLE = 262144U };

  enum { STATE_SELFVOICING = 524288U };

  enum { STATE_FOCUSABLE = 1048576U };

  enum { STATE_SELECTABLE = 2097152U };

  enum { STATE_LINKED = 4194304U };

  enum { STATE_TRAVERSED = 8388608U };

  enum { STATE_MULTISELECTABLE = 16777216U };

  enum { STATE_EXTSELECTABLE = 33554432U };

  enum { STATE_ALERT_LOW = 67108864U };

  enum { STATE_ALERT_MEDIUM = 134217728U };

  enum { STATE_ALERT_HIGH = 268435456U };

  enum { STATE_PROTECTED = 536870912U };

  enum { STATE_HASPOPUP = 1073741824U };

  enum { STATE_REQUIRED = 67108864U };

  enum { STATE_IMPORTANT = 134217728U };

  enum { STATE_INVALID = 268435456U };

  enum { STATE_CHECKABLE = 8192U };

  /**
 * Extended state flags (for now non-MSAA, for Java and Gnome/ATK support)
 * "Extended state flags" has seperate value space from "MSAA State flags".
 */
  enum { EXT_STATE_DEFUNCT = 524288U };

  enum { EXT_STATE_SELECTABLE_TEXT = 1048576U };

  enum { EXT_STATE_EDITABLE = 2097152U };

  enum { EXT_STATE_ACTIVE = 4194304U };

  enum { EXT_STATE_EXPANDABLE = 8388608U };

  enum { EXT_STATE_MODAL = 16777216U };

  enum { EXT_STATE_MULTI_LINE = 33554432U };

  enum { EXT_STATE_SENSITIVE = 67108864U };

  enum { EXT_STATE_SHOWING = 268435456U };

  enum { EXT_STATE_SINGLE_LINE = 536870912U };

  enum { EXT_STATE_TRANSIENT = 1073741824U };

  enum { EXT_STATE_VERTICAL = 2147483648U };

  /**
 * Relation Types -- most of these come from ATK's atkrelationtype.h
 * When adding support for relations, make sure to add them to appropriate
 * places in nsAccessibleWrap implementations
 * RELATION_NULL:
 * RELATION_CONTROLLED_BY:    Controlled by one or more target objects.
 * RELATION_CONTROLLER_FOR:   Controller for one or more target objects.
 * RELATION_LABEL_FOR:        Label for one or more target objects.
 * RELATION_LABELLED_BY:      Labelled by one or more target objects.
 * RELATION_MEMBER_OF:        Member of a group of one or more target objects.
 * RELATION_NODE_CHILD_OF:    Cell in a treetable which is displayed because a
 *                            cell in the same col is expanded & identifies it.
 * RELATION_FLOWS_TO:         Has content that flows logically to another
 *                            object in a sequential way, e.g. text flow.
 * RELATION_FLOWS_FROM:       Has content that flows logically from another
 *                            object in a sequential way, e.g. text flow.
 * RELATION_SUBWINDOW_OF:     Subwindow attached to a component but otherwise 
 *                            not connected in the UI hierarchy to that component.
 * RELATION_EMBEDS:           Visually embeds another object's content, i.e.
 *                            this object's content flows around another's content.
 * RELATION_EMBEDDED_BY:      Inverse of RELATION_EMBEDS; this object's content
 *                            is visually embedded in another object.
 * RELATION_POPUP_FOR:        Popup for another object.
 * RELATION_PARENT_WINDOW_OF: Parent window of another object.
 * RELATION_DEFAULT_BUTTON:   Part of a form/dialog with a related default button.
 * RELATION_DESCRIBED_BY:     Described by one or more target objects.
 * RELATION_DESCRIPTION_FOR:  Description for one or more target objects.
 */
  enum { RELATION_NUL = 0U };

  enum { RELATION_CONTROLLED_BY = 1U };

  enum { RELATION_CONTROLLER_FOR = 2U };

  enum { RELATION_LABEL_FOR = 3U };

  enum { RELATION_LABELLED_BY = 4U };

  enum { RELATION_MEMBER_OF = 5U };

  enum { RELATION_NODE_CHILD_OF = 6U };

  enum { RELATION_FLOWS_TO = 7U };

  enum { RELATION_FLOWS_FROM = 8U };

  enum { RELATION_SUBWINDOW_OF = 9U };

  enum { RELATION_EMBEDS = 10U };

  enum { RELATION_EMBEDDED_BY = 11U };

  enum { RELATION_POPUP_FOR = 12U };

  enum { RELATION_PARENT_WINDOW_OF = 13U };

  enum { RELATION_DESCRIBED_BY = 14U };

  enum { RELATION_DESCRIPTION_FOR = 15U };

  enum { RELATION_DEFAULT_BUTTON = 16384U };

  enum { ROLE_NOTHING = 0U };

  enum { ROLE_TITLEBAR = 1U };

  enum { ROLE_MENUBAR = 2U };

  enum { ROLE_SCROLLBAR = 3U };

  enum { ROLE_GRIP = 4U };

  enum { ROLE_SOUND = 5U };

  enum { ROLE_CURSOR = 6U };

  enum { ROLE_CARET = 7U };

  enum { ROLE_ALERT = 8U };

  enum { ROLE_WINDOW = 9U };

  enum { ROLE_CLIENT = 10U };

  enum { ROLE_MENUPOPUP = 11U };

  enum { ROLE_MENUITEM = 12U };

  enum { ROLE_TOOLTIP = 13U };

  enum { ROLE_APPLICATION = 14U };

  enum { ROLE_DOCUMENT = 15U };

  enum { ROLE_PANE = 16U };

  enum { ROLE_CHART = 17U };

  enum { ROLE_DIALOG = 18U };

  enum { ROLE_BORDER = 19U };

  enum { ROLE_GROUPING = 20U };

  enum { ROLE_SEPARATOR = 21U };

  enum { ROLE_TOOLBAR = 22U };

  enum { ROLE_STATUSBAR = 23U };

  enum { ROLE_TABLE = 24U };

  enum { ROLE_COLUMNHEADER = 25U };

  enum { ROLE_ROWHEADER = 26U };

  enum { ROLE_COLUMN = 27U };

  enum { ROLE_ROW = 28U };

  enum { ROLE_CELL = 29U };

  enum { ROLE_LINK = 30U };

  enum { ROLE_HELPBALLOON = 31U };

  enum { ROLE_CHARACTER = 32U };

  enum { ROLE_LIST = 33U };

  enum { ROLE_LISTITEM = 34U };

  enum { ROLE_OUTLINE = 35U };

  enum { ROLE_OUTLINEITEM = 36U };

  enum { ROLE_PAGETAB = 37U };

  enum { ROLE_PROPERTYPAGE = 38U };

  enum { ROLE_INDICATOR = 39U };

  enum { ROLE_GRAPHIC = 40U };

  enum { ROLE_STATICTEXT = 41U };

  enum { ROLE_TEXT_LEAF = 42U };

  enum { ROLE_PUSHBUTTON = 43U };

  enum { ROLE_CHECKBUTTON = 44U };

  enum { ROLE_RADIOBUTTON = 45U };

  enum { ROLE_COMBOBOX = 46U };

  enum { ROLE_DROPLIST = 47U };

  enum { ROLE_PROGRESSBAR = 48U };

  enum { ROLE_DIAL = 49U };

  enum { ROLE_HOTKEYFIELD = 50U };

  enum { ROLE_SLIDER = 51U };

  enum { ROLE_SPINBUTTON = 52U };

  enum { ROLE_DIAGRAM = 53U };

  enum { ROLE_ANIMATION = 54U };

  enum { ROLE_EQUATION = 55U };

  enum { ROLE_BUTTONDROPDOWN = 56U };

  enum { ROLE_BUTTONMENU = 57U };

  enum { ROLE_BUTTONDROPDOWNGRID = 58U };

  enum { ROLE_WHITESPACE = 59U };

  enum { ROLE_PAGETABLIST = 60U };

  enum { ROLE_CLOCK = 61U };

  enum { ROLE_SPLITBUTTON = 62U };

  enum { ROLE_IPADDRESS = 63U };

  enum { ROLE_ACCEL_LABEL = 64U };

  enum { ROLE_ARROW = 65U };

  enum { ROLE_CANVAS = 66U };

  enum { ROLE_CHECK_MENU_ITEM = 67U };

  enum { ROLE_COLOR_CHOOSER = 68U };

  enum { ROLE_DATE_EDITOR = 69U };

  enum { ROLE_DESKTOP_ICON = 70U };

  enum { ROLE_DESKTOP_FRAME = 71U };

  enum { ROLE_DIRECTORY_PANE = 72U };

  enum { ROLE_FILE_CHOOSER = 73U };

  enum { ROLE_FONT_CHOOSER = 74U };

  enum { ROLE_CHROME_WINDOW = 75U };

  enum { ROLE_GLASS_PANE = 76U };

  enum { ROLE_HTML_CONTAINER = 77U };

  enum { ROLE_ICON = 78U };

  enum { ROLE_LABEL = 79U };

  enum { ROLE_LAYERED_PANE = 80U };

  enum { ROLE_OPTION_PANE = 81U };

  enum { ROLE_PASSWORD_TEXT = 82U };

  enum { ROLE_POPUP_MENU = 83U };

  enum { ROLE_RADIO_MENU_ITEM = 84U };

  enum { ROLE_ROOT_PANE = 85U };

  enum { ROLE_SCROLL_PANE = 86U };

  enum { ROLE_SPLIT_PANE = 87U };

  enum { ROLE_TABLE_COLUMN_HEADER = 88U };

  enum { ROLE_TABLE_ROW_HEADER = 89U };

  enum { ROLE_TEAR_OFF_MENU_ITEM = 90U };

  enum { ROLE_TERMINAL = 91U };

  enum { ROLE_TEXT_CONTAINER = 92U };

  enum { ROLE_TOGGLE_BUTTON = 93U };

  enum { ROLE_TREE_TABLE = 94U };

  enum { ROLE_VIEWPORT = 95U };

  enum { ROLE_HEADER = 96U };

  enum { ROLE_FOOTER = 97U };

  enum { ROLE_PARAGRAPH = 98U };

  enum { ROLE_RULER = 99U };

  enum { ROLE_AUTOCOMPLETE = 100U };

  enum { ROLE_EDITBAR = 101U };

  enum { ROLE_ENTRY = 102U };

  enum { ROLE_CAPTION = 103U };

  enum { ROLE_DOCUMENT_FRAME = 104U };

  enum { ROLE_HEADING = 105U };

  enum { ROLE_PAGE = 106U };

  enum { ROLE_SECTION = 107U };

  enum { ROLE_REDUNDANT_OBJECT = 108U };

  enum { ROLE_FORM = 109U };

  enum { ROLE_IME = 110U };

  enum { ROLE_APP_ROOT = 111U };

  enum { ROLE_PARENT_MENUITEM = 112U };

  enum { ROLE_LAST_ENTRY = 113U };

  enum { NAVRELATION_CONTROLLED_BY = 4096U };

  enum { NAVRELATION_CONTROLLER_FOR = 4097U };

  enum { NAVRELATION_LABEL_FOR = 4098U };

  enum { NAVRELATION_LABELLED_BY = 4099U };

  enum { NAVRELATION_MEMBER_OF = 4100U };

  enum { NAVRELATION_NODE_CHILD_OF = 4101U };

  enum { NAVRELATION_FLOWS_TO = 4102U };

  enum { NAVRELATION_FLOWS_FROM = 4103U };

  enum { NAVRELATION_SUBWINDOW_OF = 4104U };

  enum { NAVRELATION_EMBEDS = 4105U };

  enum { NAVRELATION_EMBEDDED_BY = 4106U };

  enum { NAVRELATION_POPUP_FOR = 4107U };

  enum { NAVRELATION_PARENT_WINDOW_OF = 4108U };

  enum { NAVRELATION_DEFAULT_BUTTON = 4109U };

  enum { NAVRELATION_DESCRIBED_BY = 4110U };

  enum { NAVRELATION_DESCRIPTION_FOR = 4111U };

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIAccessible, NS_IACCESSIBLE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIACCESSIBLE \
  NS_IMETHOD GetParent(nsIAccessible * *aParent); \
  NS_IMETHOD GetNextSibling(nsIAccessible * *aNextSibling); \
  NS_IMETHOD GetPreviousSibling(nsIAccessible * *aPreviousSibling); \
  NS_IMETHOD GetFirstChild(nsIAccessible * *aFirstChild); \
  NS_IMETHOD GetLastChild(nsIAccessible * *aLastChild); \
  NS_IMETHOD GetChildren(nsIArray * *aChildren); \
  NS_IMETHOD GetChildCount(PRInt32 *aChildCount); \
  NS_IMETHOD GetIndexInParent(PRInt32 *aIndexInParent); \
  NS_IMETHOD GetName(nsAString & aName); \
  NS_IMETHOD SetName(const nsAString & aName); \
  NS_IMETHOD GetValue(nsAString & aValue); \
  NS_IMETHOD GetDescription(nsAString & aDescription); \
  NS_IMETHOD GetKeyboardShortcut(nsAString & aKeyboardShortcut); \
  NS_IMETHOD GetKeyBinding(nsAString & aKeyBinding); \
  NS_IMETHOD GetRole(PRUint32 *aRole); \
  NS_IMETHOD GetFinalRole(PRUint32 *aFinalRole); \
  NS_IMETHOD GetFinalState(PRUint32 *aFinalState); \
  NS_IMETHOD GetExtState(PRUint32 *aExtState); \
  NS_IMETHOD GetIsEditable(PRBool *aIsEditable); \
  NS_IMETHOD GetHelp(nsAString & aHelp); \
  NS_IMETHOD GetFocusedChild(nsIAccessible * *aFocusedChild); \
  NS_IMETHOD GetAttributes(nsIPersistentProperties * *aAttributes); \
  NS_IMETHOD GetChildAtPoint(PRInt32 x, PRInt32 y, nsIAccessible **_retval); \
  NS_IMETHOD GetChildAt(PRInt32 aChildIndex, nsIAccessible **_retval); \
  NS_IMETHOD GetAccessibleToRight(nsIAccessible **_retval); \
  NS_IMETHOD GetAccessibleToLeft(nsIAccessible **_retval); \
  NS_IMETHOD GetAccessibleAbove(nsIAccessible **_retval); \
  NS_IMETHOD GetAccessibleBelow(nsIAccessible **_retval); \
  NS_IMETHOD GetAccessibleRelated(PRUint32 aRelationType, nsIAccessible **_retval); \
  NS_IMETHOD GetBounds(PRInt32 *x, PRInt32 *y, PRInt32 *width, PRInt32 *height); \
  NS_IMETHOD SetSelected(PRBool isSelected); \
  NS_IMETHOD ExtendSelection(void); \
  NS_IMETHOD TakeSelection(void); \
  NS_IMETHOD TakeFocus(void); \
  NS_IMETHOD GetNumActions(PRUint8 *aNumActions); \
  NS_IMETHOD GetActionName(PRUint8 index, nsAString & _retval); \
  NS_IMETHOD DoAction(PRUint8 index); \
  NS_IMETHOD GetNativeInterface(void * *aOutAccessible); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIACCESSIBLE(_to) \
  NS_IMETHOD GetParent(nsIAccessible * *aParent) { return _to GetParent(aParent); } \
  NS_IMETHOD GetNextSibling(nsIAccessible * *aNextSibling) { return _to GetNextSibling(aNextSibling); } \
  NS_IMETHOD GetPreviousSibling(nsIAccessible * *aPreviousSibling) { return _to GetPreviousSibling(aPreviousSibling); } \
  NS_IMETHOD GetFirstChild(nsIAccessible * *aFirstChild) { return _to GetFirstChild(aFirstChild); } \
  NS_IMETHOD GetLastChild(nsIAccessible * *aLastChild) { return _to GetLastChild(aLastChild); } \
  NS_IMETHOD GetChildren(nsIArray * *aChildren) { return _to GetChildren(aChildren); } \
  NS_IMETHOD GetChildCount(PRInt32 *aChildCount) { return _to GetChildCount(aChildCount); } \
  NS_IMETHOD GetIndexInParent(PRInt32 *aIndexInParent) { return _to GetIndexInParent(aIndexInParent); } \
  NS_IMETHOD GetName(nsAString & aName) { return _to GetName(aName); } \
  NS_IMETHOD SetName(const nsAString & aName) { return _to SetName(aName); } \
  NS_IMETHOD GetValue(nsAString & aValue) { return _to GetValue(aValue); } \
  NS_IMETHOD GetDescription(nsAString & aDescription) { return _to GetDescription(aDescription); } \
  NS_IMETHOD GetKeyboardShortcut(nsAString & aKeyboardShortcut) { return _to GetKeyboardShortcut(aKeyboardShortcut); } \
  NS_IMETHOD GetKeyBinding(nsAString & aKeyBinding) { return _to GetKeyBinding(aKeyBinding); } \
  NS_IMETHOD GetRole(PRUint32 *aRole) { return _to GetRole(aRole); } \
  NS_IMETHOD GetFinalRole(PRUint32 *aFinalRole) { return _to GetFinalRole(aFinalRole); } \
  NS_IMETHOD GetFinalState(PRUint32 *aFinalState) { return _to GetFinalState(aFinalState); } \
  NS_IMETHOD GetExtState(PRUint32 *aExtState) { return _to GetExtState(aExtState); } \
  NS_IMETHOD GetIsEditable(PRBool *aIsEditable) { return _to GetIsEditable(aIsEditable); } \
  NS_IMETHOD GetHelp(nsAString & aHelp) { return _to GetHelp(aHelp); } \
  NS_IMETHOD GetFocusedChild(nsIAccessible * *aFocusedChild) { return _to GetFocusedChild(aFocusedChild); } \
  NS_IMETHOD GetAttributes(nsIPersistentProperties * *aAttributes) { return _to GetAttributes(aAttributes); } \
  NS_IMETHOD GetChildAtPoint(PRInt32 x, PRInt32 y, nsIAccessible **_retval) { return _to GetChildAtPoint(x, y, _retval); } \
  NS_IMETHOD GetChildAt(PRInt32 aChildIndex, nsIAccessible **_retval) { return _to GetChildAt(aChildIndex, _retval); } \
  NS_IMETHOD GetAccessibleToRight(nsIAccessible **_retval) { return _to GetAccessibleToRight(_retval); } \
  NS_IMETHOD GetAccessibleToLeft(nsIAccessible **_retval) { return _to GetAccessibleToLeft(_retval); } \
  NS_IMETHOD GetAccessibleAbove(nsIAccessible **_retval) { return _to GetAccessibleAbove(_retval); } \
  NS_IMETHOD GetAccessibleBelow(nsIAccessible **_retval) { return _to GetAccessibleBelow(_retval); } \
  NS_IMETHOD GetAccessibleRelated(PRUint32 aRelationType, nsIAccessible **_retval) { return _to GetAccessibleRelated(aRelationType, _retval); } \
  NS_IMETHOD GetBounds(PRInt32 *x, PRInt32 *y, PRInt32 *width, PRInt32 *height) { return _to GetBounds(x, y, width, height); } \
  NS_IMETHOD SetSelected(PRBool isSelected) { return _to SetSelected(isSelected); } \
  NS_IMETHOD ExtendSelection(void) { return _to ExtendSelection(); } \
  NS_IMETHOD TakeSelection(void) { return _to TakeSelection(); } \
  NS_IMETHOD TakeFocus(void) { return _to TakeFocus(); } \
  NS_IMETHOD GetNumActions(PRUint8 *aNumActions) { return _to GetNumActions(aNumActions); } \
  NS_IMETHOD GetActionName(PRUint8 index, nsAString & _retval) { return _to GetActionName(index, _retval); } \
  NS_IMETHOD DoAction(PRUint8 index) { return _to DoAction(index); } \
  NS_IMETHOD GetNativeInterface(void * *aOutAccessible) { return _to GetNativeInterface(aOutAccessible); } \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIACCESSIBLE(_to) \
  NS_IMETHOD GetParent(nsIAccessible * *aParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetParent(aParent); } \
  NS_IMETHOD GetNextSibling(nsIAccessible * *aNextSibling) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNextSibling(aNextSibling); } \
  NS_IMETHOD GetPreviousSibling(nsIAccessible * *aPreviousSibling) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPreviousSibling(aPreviousSibling); } \
  NS_IMETHOD GetFirstChild(nsIAccessible * *aFirstChild) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFirstChild(aFirstChild); } \
  NS_IMETHOD GetLastChild(nsIAccessible * *aLastChild) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLastChild(aLastChild); } \
  NS_IMETHOD GetChildren(nsIArray * *aChildren) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChildren(aChildren); } \
  NS_IMETHOD GetChildCount(PRInt32 *aChildCount) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChildCount(aChildCount); } \
  NS_IMETHOD GetIndexInParent(PRInt32 *aIndexInParent) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIndexInParent(aIndexInParent); } \
  NS_IMETHOD GetName(nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetName(aName); } \
  NS_IMETHOD SetName(const nsAString & aName) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetName(aName); } \
  NS_IMETHOD GetValue(nsAString & aValue) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValue(aValue); } \
  NS_IMETHOD GetDescription(nsAString & aDescription) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDescription(aDescription); } \
  NS_IMETHOD GetKeyboardShortcut(nsAString & aKeyboardShortcut) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeyboardShortcut(aKeyboardShortcut); } \
  NS_IMETHOD GetKeyBinding(nsAString & aKeyBinding) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetKeyBinding(aKeyBinding); } \
  NS_IMETHOD GetRole(PRUint32 *aRole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRole(aRole); } \
  NS_IMETHOD GetFinalRole(PRUint32 *aFinalRole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFinalRole(aFinalRole); } \
  NS_IMETHOD GetFinalState(PRUint32 *aFinalState) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFinalState(aFinalState); } \
  NS_IMETHOD GetExtState(PRUint32 *aExtState) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExtState(aExtState); } \
  NS_IMETHOD GetIsEditable(PRBool *aIsEditable) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIsEditable(aIsEditable); } \
  NS_IMETHOD GetHelp(nsAString & aHelp) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHelp(aHelp); } \
  NS_IMETHOD GetFocusedChild(nsIAccessible * *aFocusedChild) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFocusedChild(aFocusedChild); } \
  NS_IMETHOD GetAttributes(nsIPersistentProperties * *aAttributes) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAttributes(aAttributes); } \
  NS_IMETHOD GetChildAtPoint(PRInt32 x, PRInt32 y, nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChildAtPoint(x, y, _retval); } \
  NS_IMETHOD GetChildAt(PRInt32 aChildIndex, nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChildAt(aChildIndex, _retval); } \
  NS_IMETHOD GetAccessibleToRight(nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccessibleToRight(_retval); } \
  NS_IMETHOD GetAccessibleToLeft(nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccessibleToLeft(_retval); } \
  NS_IMETHOD GetAccessibleAbove(nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccessibleAbove(_retval); } \
  NS_IMETHOD GetAccessibleBelow(nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccessibleBelow(_retval); } \
  NS_IMETHOD GetAccessibleRelated(PRUint32 aRelationType, nsIAccessible **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAccessibleRelated(aRelationType, _retval); } \
  NS_IMETHOD GetBounds(PRInt32 *x, PRInt32 *y, PRInt32 *width, PRInt32 *height) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBounds(x, y, width, height); } \
  NS_IMETHOD SetSelected(PRBool isSelected) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSelected(isSelected); } \
  NS_IMETHOD ExtendSelection(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->ExtendSelection(); } \
  NS_IMETHOD TakeSelection(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->TakeSelection(); } \
  NS_IMETHOD TakeFocus(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->TakeFocus(); } \
  NS_IMETHOD GetNumActions(PRUint8 *aNumActions) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNumActions(aNumActions); } \
  NS_IMETHOD GetActionName(PRUint8 index, nsAString & _retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetActionName(index, _retval); } \
  NS_IMETHOD DoAction(PRUint8 index) { return !_to ? NS_ERROR_NULL_POINTER : _to->DoAction(index); } \
  NS_IMETHOD GetNativeInterface(void * *aOutAccessible) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNativeInterface(aOutAccessible); } \

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsAccessible : public nsIAccessible
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIACCESSIBLE

  nsAccessible();

private:
  ~nsAccessible();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsAccessible, nsIAccessible)

nsAccessible::nsAccessible()
{
  /* member initializers and constructor code */
}

nsAccessible::~nsAccessible()
{
  /* destructor code */
}

/* readonly attribute nsIAccessible parent; */
NS_IMETHODIMP nsAccessible::GetParent(nsIAccessible * *aParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAccessible nextSibling; */
NS_IMETHODIMP nsAccessible::GetNextSibling(nsIAccessible * *aNextSibling)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAccessible previousSibling; */
NS_IMETHODIMP nsAccessible::GetPreviousSibling(nsIAccessible * *aPreviousSibling)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAccessible firstChild; */
NS_IMETHODIMP nsAccessible::GetFirstChild(nsIAccessible * *aFirstChild)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAccessible lastChild; */
NS_IMETHODIMP nsAccessible::GetLastChild(nsIAccessible * *aLastChild)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIArray children; */
NS_IMETHODIMP nsAccessible::GetChildren(nsIArray * *aChildren)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long childCount; */
NS_IMETHODIMP nsAccessible::GetChildCount(PRInt32 *aChildCount)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute long indexInParent; */
NS_IMETHODIMP nsAccessible::GetIndexInParent(PRInt32 *aIndexInParent)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute AString name; */
NS_IMETHODIMP nsAccessible::GetName(nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsAccessible::SetName(const nsAString & aName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString value; */
NS_IMETHODIMP nsAccessible::GetValue(nsAString & aValue)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString description; */
NS_IMETHODIMP nsAccessible::GetDescription(nsAString & aDescription)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString keyboardShortcut; */
NS_IMETHODIMP nsAccessible::GetKeyboardShortcut(nsAString & aKeyboardShortcut)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString keyBinding; */
NS_IMETHODIMP nsAccessible::GetKeyBinding(nsAString & aKeyBinding)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long role; */
NS_IMETHODIMP nsAccessible::GetRole(PRUint32 *aRole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long finalRole; */
NS_IMETHODIMP nsAccessible::GetFinalRole(PRUint32 *aFinalRole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long finalState; */
NS_IMETHODIMP nsAccessible::GetFinalState(PRUint32 *aFinalState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long extState; */
NS_IMETHODIMP nsAccessible::GetExtState(PRUint32 *aExtState)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean isEditable; */
NS_IMETHODIMP nsAccessible::GetIsEditable(PRBool *aIsEditable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString help; */
NS_IMETHODIMP nsAccessible::GetHelp(nsAString & aHelp)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIAccessible focusedChild; */
NS_IMETHODIMP nsAccessible::GetFocusedChild(nsIAccessible * *aFocusedChild)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPersistentProperties attributes; */
NS_IMETHODIMP nsAccessible::GetAttributes(nsIPersistentProperties * *aAttributes)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getChildAtPoint (in long x, in long y); */
NS_IMETHODIMP nsAccessible::GetChildAtPoint(PRInt32 x, PRInt32 y, nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getChildAt (in long aChildIndex); */
NS_IMETHODIMP nsAccessible::GetChildAt(PRInt32 aChildIndex, nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getAccessibleToRight (); */
NS_IMETHODIMP nsAccessible::GetAccessibleToRight(nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getAccessibleToLeft (); */
NS_IMETHODIMP nsAccessible::GetAccessibleToLeft(nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getAccessibleAbove (); */
NS_IMETHODIMP nsAccessible::GetAccessibleAbove(nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getAccessibleBelow (); */
NS_IMETHODIMP nsAccessible::GetAccessibleBelow(nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIAccessible getAccessibleRelated (in unsigned long aRelationType); */
NS_IMETHODIMP nsAccessible::GetAccessibleRelated(PRUint32 aRelationType, nsIAccessible **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getBounds (out long x, out long y, out long width, out long height); */
NS_IMETHODIMP nsAccessible::GetBounds(PRInt32 *x, PRInt32 *y, PRInt32 *width, PRInt32 *height)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void setSelected (in boolean isSelected); */
NS_IMETHODIMP nsAccessible::SetSelected(PRBool isSelected)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void extendSelection (); */
NS_IMETHODIMP nsAccessible::ExtendSelection()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void takeSelection (); */
NS_IMETHODIMP nsAccessible::TakeSelection()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void takeFocus (); */
NS_IMETHODIMP nsAccessible::TakeFocus()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute PRUint8 numActions; */
NS_IMETHODIMP nsAccessible::GetNumActions(PRUint8 *aNumActions)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AString getActionName (in PRUint8 index); */
NS_IMETHODIMP nsAccessible::GetActionName(PRUint8 index, nsAString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void doAction (in PRUint8 index); */
NS_IMETHODIMP nsAccessible::DoAction(PRUint8 index)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] void getNativeInterface (out voidPtr aOutAccessible); */
NS_IMETHODIMP nsAccessible::GetNativeInterface(void * *aOutAccessible)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIAccessible_h__ */
